#!/usr/bin/env python
# -*- coding:Utf-8 -*-
# Module tazer
# Official Addons
# By Sicilia

import es, playerlib, gamethread, effectlib, random

dico_tazer = {}
max_tazer = es.ServerVar("max_tazer")
temps_tazer = es.ServerVar("temps_tazer")


def load():
    es.regclientcmd("!tazer", "sici_jail/modules/tazer/player_cmd_tazer", "remove closest weapon")
    es.regsaycmd("!tazer", "sici_jail/modules/tazer/player_cmd_tazer", "remove closest weapon")
    es.dbgmsg(0, '[Sici Jail] Modules : Tazer On')
   
def GetViewProp(userid):
   returnvalue = 0
   if not int(es.ServerVar("sv_cheats")):
      es.forcevalue("sv_cheats", 1)
      es.sexec(userid, "ent_setname viewed_prop")
      es.forcevalue("sv_cheats", 0)
   else:
      es.sexec(userid, "ent_setname viewed_prop")
   for index in es.createentitylist():
      if (es.entitygetvalue(index, "targetname") != "viewed_prop"):
         continue
      returnvalue = index
      es.entitysetvalue(index, "targetname", "")
   return returnvalue

def GetViewPlayer(userid):
   returnvalue = 0
   index = GetViewProp(userid)
   players = es.createplayerlist()
   for player in players:
      if (players[player]["index"] != index):
         continue
      returnvalue = player
   return returnvalue

def player_cmd_tazer():
    global dico_tazer    
    userid_cmd = es.getcmduserid()
    if not userid_cmd in dico_tazer:
        dico_tazer[userid_cmd] = [0, False]    
    team = es.getplayerteam(userid_cmd)
    if team == 3:
        if dico_tazer[userid_cmd][0] != int(max_tazer):
            if not dico_tazer[userid_cmd][1]:
                player = playerlib.getPlayer(userid_cmd)
                if player.get("isdead") == 0:
                    exists_cible = GetViewPlayer(userid_cmd)
                    if int(exists_cible) != 0:            
                        team_vise = es.getplayerteam(exists_cible)
                        if team_vise == 2:
                            utilisation_tazer = dico_tazer[userid_cmd][0]
                            tazer_actif = dico_tazer[userid_cmd][1]
                
                            if utilisation_tazer < int(max_tazer) and not tazer_actif:
                                utilisation_tazer += 1
                                dico_tazer[userid_cmd][0] = utilisation_tazer
            
                                location_cible = es.getplayerlocation(exists_cible)
                                location_user = es.getplayerlocation(userid_cmd)
                                es.effect('sparks', es.createvectorstring(location_cible[0], location_cible[1], location_cible[2] + 70) , 100, 3, 0)
                                location_cible = (location_cible[0], location_cible[1], location_cible[2] + 60)
                                location_user = (location_user[0], location_user[1], location_user[2] + 45)
                                effectlib.drawLine(location_user, location_cible, seconds = 3, speed = 1 ,brightness = 255 ,model = "materials/sprites/laser.vmt", blue = 255, green = 0, red = 0)
                                es.emitsound('player', exists_cible, 'ambient/machines/zap' + str(random.randint(1, 3)) + '.wav', 1.0, 0.5)
                                es.emitsound('player', exists_cible, 'bot/aah.wav', 1.0, 0.5)
                                enlever_arme_tazer(userid_cmd, exists_cible)
                                name = es.getplayername(userid_cmd)
                                name_tazer = es.getplayername(exists_cible)  
                                es.msg("#multi", "#lightgreen[#greenSici Jail#lightgreen] #lightgreen%s #default est tazer !!! pendant #green%s#default sec par #lightgreen%s#default." % (name_tazer, temps_tazer, name))
            else: es.tell(userid_cmd, "#multi", "#lightgreen[#greenSici Jail#lightgreen] #defaultTon #green'!tazer'#default est deja en cour d'utilisation.")
                        # sinon dire au joueur qu'il a dépassé son quota
        else: es.tell(userid_cmd, "#multi", "#lightgreen[#greenSici Jail#lightgreen] #defaultTes #lightgreen'!tazer'#default ont déjà été tous utilisés.")
def round_start(E):
    global dico_tazer
    dico_tazer.clear()
    
def player_spawn(E):
    if E["es_userteam"] == "3":
        es.tell(E["userid"], "#multi", "#lightgreen[#greenSici Jail#lightgreen] #defaultOublie pas pour freezer un détenu : #green!tazer")
    
def enlever_arme_tazer(userid, cible):
    global dico_tazer
    dico_tazer[userid][1] = True
    es.server.cmd("es_xfire %s player_weaponstrip kill;" % cible +
                  "es_xgive %s player_weaponstrip;" % cible +
                  "es_xfire %s player_weaponstrip strip" % cible)
    es.setplayerprop(cible, "CBasePlayer.m_lifeState", 0)
    es.setplayerprop(cible, "CBasePlayer.m_fFlags", 32.0)
    gamethread.delayed(temps_tazer, regive_vie, (userid, cible))
    
def regive_vie(userid, cible):
    global dico_tazer
    dico_tazer[userid][1] = False
    es.server.queuecmd("es_xgive %s weapon_knife" % cible)
    es.setplayerprop(cible, "CBasePlayer.m_lifeState", 512)
    es.setplayerprop(cible, "CBasePlayer.m_fFlags", 66177)

def unload():
    es.unregclientcmd("!tazer")    
    es.unregsaycmd("!tazer")
    es.dbgmsg(0, '[Sici Jail] Modules : Tazer Off') 